#include "F:\SOFTWARE\Dev\ETH\Common Firmware\TCPIPCore.h"
#include "ETH-IIRO-16.h"


void Discovery_Go(uint8 xdata * data_buf)
{
    uint16 xdata len;
    uint8 xdata destip[4];
    uint16 xdata fromport;
    
    switch(IINCHIP_READ(Sn_SR(DISC_UDP_SOCK)))
    {
        case SOCK_UDP:
            if ((len = getSn_RX_RSR(DISC_UDP_SOCK)) > 0)                   // check the size of received data
            {       
                len = recvfrom(DISC_UDP_SOCK, data_buf, len, (uint8*)destip, &fromport);  
                
                dprintf("DiscoveryUDP : Received %d bytes from %bu.%bu.%bu.%bu =", len, destip[0], destip[1], destip[2], destip[3]);
                
                { uint8 i; for (i=0; i<len; ++i) dprintf(" %02bX", data_buf[i]); } dprintf("\r\n",0);
          
                if (len==8) 
                    if (data_buf[0] == 0xB2)
                        if (data_buf[1] == 0xD4)
                            if (data_buf[2] == 0xE5)
                                if (data_buf[3] == 0x0C)
                                    if (data_buf[4] == 0x26)
                                        if (data_buf[5] == 0xD4)
                                            if (data_buf[6] == 0x77)
                                                if (data_buf[7] == 0x46)
                                                { 
                                                    dprintf("DiscoveryUDP : Discovery Broadcast Detected\r\n",0);                                     
                                                    sendto(DISC_UDP_SOCK, data_buf, len, destip, DISC_RESP_PORT); // CLEARS SUBNET. WHY?!?
                                                    SetSubnet(NetworkParam.subnet); ApplySubnet(); // put subnet BACK. Why was it being cleared?! Cannot receive another broadcast without it set.
                                                }
            }
        break;
                                                          
        case SOCK_CLOSED:                
            dprintf("DiscoveryUDP : socket\r\n",0);                                          
            socket(DISC_UDP_SOCK, Sn_MR_UDP, DISC_PORT, 0);                  
        break;
    
        default:
        break;
    }
}

