#include <stdio.h>
#include <ctype.h>
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\serial.h"         // serial related functions
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\socket.h"         // W7100A driver file
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\types.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\w7100.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\Wizmemcpy.h"

#include "F:\SOFTWARE\Dev\ETH\Common Firmware\TCPIPCore.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\delay.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\codeflash.h"
#include "task_config.h"
#include "ETH-IIRO-16.h"
#include "iap.h"
#include "dhcp.h"
#include "discovery.h"
#include "update.h"

uint8 xdata temp = 0;
uint8 xdata txsize[MAX_SOCK_NUM] = {8,2,1,1,1,1,1,1};
uint8 xdata rxsize[MAX_SOCK_NUM] = {8,2,1,1,1,1,1,1};
//uint8 xdata txsize[MAX_SOCK_NUM] = {2,2,2,2,2,2,2,2};
//uint8 xdata rxsize[MAX_SOCK_NUM] = {2,2,2,2,2,2,2,2};

extern uint8 currentIDO[3];

void Init_iMCU2(void);
void TickActivity();

// DHCP stuff
uint8 xdata Enable_DHCP_Timer;
uint8 xdata DHCP_flag;
uint8 OPT2Already;
uint8 OPT1Already;
uint8 fActivity;
static xdata char data_buf[MAX_BUF_SIZE];

#define MAX_UPLOAD_BUF_SIZE 256
static xdata char Upload_data_buf[MAX_UPLOAD_BUF_SIZE];

void SetLED() { LED0 = 0; }
void ClrLED(){ LED0 = 1; }

void Init_Net_Default();
void main()
{
    SetLED();
    
    Init_iMCU2();
    set_MEMsize(txsize,rxsize);
    
    printf("\r\n%s\r\nModel %s Firmware Revision %bx.%bx build:%s @ %s \r", COMPANY, MODEL, VER_H, VER_L,__DATE2__, __TIME__);
 
    wait_1ms(100);
    ClrLED();
    wait_1ms(100);
    SetLED();    
    wait_1ms(100);
    ClrLED();
    wait_1ms(100);
    SetLED();    
    
    SetConfig();  // either static or DHCP configuration of network parameters
    
    ClrLED();
    wait_1ms(50);
    SetLED();
    wait_1ms(50);
    ClrLED();
    wait_1ms(50);
    SetLED();    
    wait_1ms(50);
    ClrLED();
    wait_1ms(50);
    SetLED();    
    wait_1ms(50);
    ClrLED();
    wait_1ms(40);
    SetLED();   
    P2_3 = 0;         
    P2_0 = 0; 
    
    printf( "MAC ADDRESS IP     : %.2bx.%.2bx.%.2bx.%.2bx.%.2bx.%.2bx\r\n", IINCHIP_READ (SHAR0+0), IINCHIP_READ (SHAR0+1), IINCHIP_READ (SHAR0+2),  IINCHIP_READ (SHAR0+3), IINCHIP_READ (SHAR0+4), IINCHIP_READ (SHAR0+5));
    dprintf( "SUBNET MASK        : %.3bu.%.3bu.%.3bu.%.3bu\r\n", IINCHIP_READ (SUBR0+0), IINCHIP_READ (SUBR0+1), IINCHIP_READ (SUBR0+2),  IINCHIP_READ (SUBR0+3));
    dprintf( "Gateway IP ADDRESS : %.3bu.%.3bu.%.3bu.%.3bu\r\n", IINCHIP_READ (GAR0+0), IINCHIP_READ (GAR0+1), IINCHIP_READ (GAR0+2),  IINCHIP_READ (GAR0+3));
    printf( "IP ADDRESS         : %.3bu.%.3bu.%.3bu.%.3bu\r\n",  IINCHIP_READ (SIPR0+0), IINCHIP_READ (SIPR0+1), IINCHIP_READ (SIPR0+2),  IINCHIP_READ (SIPR0+3));
        
    fActivity = 1;

    while(1)
    {
        ETH_Firmware_Update_Go(0, UPLD_PORT, Upload_data_buf);
        ETH_IIRO_16_Go(1, TALK_PORT, data_buf);
        ETH_IIRO_16_Go(2, TALK_PORT, data_buf);
        ETH_IIRO_16_Go(3, TALK_PORT, data_buf);
        ETH_IIRO_16_Go(4, TALK_PORT, data_buf);
        ETH_IIRO_16_Go(5, TALK_PORT, data_buf);
        ETH_IIRO_16_Go(6, TALK_PORT, data_buf);
     
        Discovery_Go(data_buf); // consumes socket 7

        TickActivity();

        if (Asynch_Reset)     // if a ChNW was issued we wait for a while in the hopes the transaction will close before we change the parameters
        {
            Asynch_Reset--;
            wait_1ms(1);
            if (!Asynch_Reset)
            {
                setSIPR( NetworkParam.ip );
                setSUBR( NetworkParam.subnet );
                setGAR( NetworkParam.gw );
            }
        }
        

        if (OPT1_Jumper != OPT2_Jumper) { // debounce, prevent from running more than once in a row, et cetera!!! --J2H TODO
            if ((OPT2_Jumper == 1) && !OPT2Already)
            {
                OPT2Already = 1;
                debug_network();
                setSIPR( NetworkParam.ip );
                printf( "IP ADDRESS         : %.3bu.%.3bu.%.3bu.%.3bu\r\n", IINCHIP_READ (SIPR0+0), IINCHIP_READ (SIPR0+1), IINCHIP_READ (SIPR0+2), IINCHIP_READ (SIPR0+3));
                fActivity = 1;
            }

            if (OPT2_Jumper == 0)
                OPT2Already = 0;

            if ((OPT1_Jumper == 1) && !OPT1Already)
            {
                OPT1Already = 1;
                default_network();
                setSIPR( NetworkParam.ip );
                printf( "IP ADDRESS         : %.3bu.%.3bu.%.3bu.%.3bu\r\n", IINCHIP_READ (SIPR0+0), IINCHIP_READ (SIPR0+1), IINCHIP_READ (SIPR0+2), IINCHIP_READ (SIPR0+3));
                fActivity = 1;
            }

            if (OPT1_Jumper == 0)
                OPT1Already = 0;
        }
        
        if ((DHCP_flag == 1) && (DHCPisSuccess == 1)) check_dhcp();       
    } // while forever
}


void Init_iMCU2(void)
{ 
    OPT2Already = 0; OPT1Already = 0;
    
	CHIP_Init(); // MCU Core init
	EA = 0; 	// Disable all interrupts 

    // added 2018-08-24 to speed DIO access through hardware_write()/_read(); 5x improvement
    EXTWTST0 = 0; EXTWTST1 = 0; // set external "memory" wait states to zero (defaulted to 65535)
    CKCON = 2; // fastest data memory read/write setting; default 7 2018-08-27
    WTST = 3; // code memory read wait-states set from default value "8 clks" to fastest value "4 clks" 2018-08-27
    INTWTST = 0x3F; // fastest RAM/default TCPFlash/Flash waitstates 2018-08-27

#ifdef __DEF_IINCHIP_INT__
	uint8 xdata i;
	IINCHIP_WRITE(IMR,0xff);
	for(i=0; i<MAX_SOCK_NUM; i++) IINCHIP_WRITE(Sn_IMR(i), 0x1f);	
	IINCHIP_ISR_ENABLE();
#endif

#ifdef USE_QFN64	
	PHY_mode_config();	// PHY setting of W7100A, this function is just for QFN 64pin package
						// Default is "000" = auto-negotiation mode
#endif
    Init_DHCPTimer0();		// EA = 1  // J2H this Causes Lockup
	InitSerial(); 	// Initialize serial port (Refer to serial.c)

	P0_PU = 0xFF;	// GPIO Pull-up setting for 3.3V output     
	P1_PU = 0xFF;
	P2_PU = 0xFF;
	P3_PU = 0xFF;
	EA = 1;

}

// Serial Interrupt Processing,
// if the Serial interrupt ES0 enable(ES0 = 1), you must include Serial interrupt handling code.
void Int() interrupt 4 { if(RI) RI = 0; }



void TickActivity()
{
  static int blinkcounter = 0;
  if (blinkcounter) {if (--blinkcounter < _ACTIVITY_LED_ON_TIME_) SetLED();}
  else if (fActivity)
  {
    blinkcounter = _ACTIVITY_LED_TIME_;
    ClrLED();
    fActivity = 0;
  }
}

















