#include <stdio.h>
#include <string.h>
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\types.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\socket.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\TCPIPCore.h"
#include "iap.h"
#include "task_config.h"
#include "ETH-IIRO-16.h"
#include "dhcp.h"

StrConfigParam NetworkParam, MSGConfig;

void setSHAR(uint8 * addr)
{
    uint8 k;

    for(k = 0; k < 6; k++) {
        IINCHIP_WRITE(((uint16)SHAR0+k), addr[k]);
    }
}

void setGAR(uint8 * addr)
{
    IINCHIP_WRITE(((uint16)(GAR0)), addr[0]);
    IINCHIP_WRITE(((uint16)(GAR0+1)), addr[1]);
    IINCHIP_WRITE(((uint16)(GAR0+2)), addr[2]);
    IINCHIP_WRITE(((uint16)(GAR0+3)),addr[3]);
}

void setSUBR(uint8 * addr)
{
    IINCHIP_WRITE(((uint16)(SUBR0)), addr[0]);
    IINCHIP_WRITE(((uint16)(SUBR0+1)), addr[1]);
    IINCHIP_WRITE(((uint16)(SUBR0+2)), addr[2]);
    IINCHIP_WRITE(((uint16)(SUBR0+3)), addr[3]);
}

void setSIPR(uint8 * addr)
{
    IINCHIP_WRITE(((uint16)(SIPR0)), addr[0]);
    IINCHIP_WRITE(((uint16)(SIPR0+1)), addr[1]);
    IINCHIP_WRITE(((uint16)(SIPR0+2)) ,addr[2]);
    IINCHIP_WRITE(((uint16)(SIPR0+3)), addr[3]);
}

void Init_Net_Default(void)
{
	uint8 tmp[4] = {0,0,0,0};

	IINCHIP_WRITE(MR,MR_RST);
	// MAC
	IINCHIP_WRITE((SHAR0 + 0), NetworkParam.mac[0]); 
    IINCHIP_WRITE((SHAR0 + 1), NetworkParam.mac[1]);
    IINCHIP_WRITE((SHAR0 + 2), NetworkParam.mac[2]);
	IINCHIP_WRITE((SHAR0 + 3), 0); // NetworkParam.mac[3]); 
    IINCHIP_WRITE((SHAR0 + 4), 0); // NetworkParam.mac[4]); 
    IINCHIP_WRITE((SHAR0 + 5), 0); // NetworkParam.mac[5]);
	// Gateway
	IINCHIP_WRITE((GAR0 + 0), tmp[0]); 
    IINCHIP_WRITE((GAR0 + 1), tmp[1]);
	IINCHIP_WRITE((GAR0 + 2), tmp[2]); 
    IINCHIP_WRITE((GAR0 + 3), tmp[3]);
	// Subnet Mask
	IINCHIP_WRITE((SUBR0 + 0), tmp[0]);
    IINCHIP_WRITE((SUBR0 + 1), tmp[1]);
	IINCHIP_WRITE((SUBR0 + 2), tmp[2]); 
    IINCHIP_WRITE((SUBR0 + 3), tmp[3]);
	// Local IP address
	IINCHIP_WRITE((SIPR0 + 0 ), tmp[0]); 
    IINCHIP_WRITE((SIPR0 + 1 ), tmp[1]);	
	IINCHIP_WRITE((SIPR0 + 2 ), tmp[2]); 
    IINCHIP_WRITE((SIPR0 + 3 ), tmp[3]);	
	
    // Retransmission Time-out Register (delay 600ms)
	IINCHIP_WRITE(RTR,(uint8)((6000 & 0xff00) >> 8)); // 600ms
	IINCHIP_WRITE((RTR + 1),(uint8)(6000 & 0x00ff));
	// Retry Count Register
	IINCHIP_WRITE(RCR, 3);

	set_MEMsize(txsize,rxsize);
}


//-----------------------------------------------------------------------------
void default_network(void)
{
    fActivity          = 1;
    NetworkParam.op[0] = 0x82;
    NetworkParam.op[1] = 0x82;
    NetworkParam.op[2] = 0x82;
    NetworkParam.op[3] = 0x82;

    NetworkParam.ver[0] = 0x00;
    NetworkParam.ver[1] = 0x00;

    // NetworkParam.mac[0] = 0x00;
    // NetworkParam.mac[1] = 0x08;
    // NetworkParam.mac[2] = 0xDC;
    // NetworkParam.mac[3] = 0x11;
    // NetworkParam.mac[4] = 0x99;
    // NetworkParam.mac[5] = 0x77;

    NetworkParam.ip[0] = 0xC0;
    NetworkParam.ip[1] = 0xA8;
    NetworkParam.ip[2] = 0x01;
    NetworkParam.ip[3] = 0xAE;

    NetworkParam.subnet[0] = 0xFF;
    NetworkParam.subnet[1] = 0xFF;
    NetworkParam.subnet[2] = 0xFF;
    NetworkParam.subnet[3] = 0x00;

    NetworkParam.gw[0] = 0xC0;
    NetworkParam.gw[1] = 0xA8;
    NetworkParam.gw[2] = 0x01;
    NetworkParam.gw[3] = 0x5E;

    NetworkParam.dhcp = 0x01;

    NetworkParam.pad = 0x00;

    user_flash_write((unsigned char *)&NetworkParam);
    OPT1Already = 1;
}

//-----------------------------------------------------------------------------
void debug_network(void)    // used if the EEPROM has nothing, or OPT2 is shorted "1"
{
    fActivity          = 1;
    NetworkParam.op[0] = 0x82;
    NetworkParam.op[1] = 0x82;
    NetworkParam.op[2] = 0x82;
    NetworkParam.op[3] = 0x82;

    NetworkParam.ver[0] = 0x00;
    NetworkParam.ver[1] = 0x00;

    NetworkParam.mac[0] = 0x00;
    NetworkParam.mac[1] = 0x08;
    NetworkParam.mac[2] = 0xDC;
    NetworkParam.mac[3] = 0x11;
    NetworkParam.mac[4] = 0x99;
    NetworkParam.mac[5] = 0x77;

    NetworkParam.ip[0] = 0x0A; //10.1.1.251 == FuBar network configuration
    NetworkParam.ip[1] = 0x01;
    NetworkParam.ip[2] = 0x01;
    NetworkParam.ip[3] = 0xFB;

    NetworkParam.subnet[0] = 0xFF;
    NetworkParam.subnet[1] = 0xFF;
    NetworkParam.subnet[2] = 0xFF;
    NetworkParam.subnet[3] = 0x00;

    NetworkParam.gw[0] = 0x0A; //10.1.1.1 == gateway in debug mode
    NetworkParam.gw[1] = 0x01;
    NetworkParam.gw[2] = 0x01;
    NetworkParam.gw[3] = 0x01;

    NetworkParam.dhcp = 0x00;

    NetworkParam.pad = 0x00;

    user_flash_write((unsigned char *)&NetworkParam);
    OPT2Already = 1;
}

void configureNetworkFromEEPROM(void)
{        
    user_flash_read((unsigned char *)&NetworkParam);
    
    if ((NetworkParam.ver[0] != VER_H)||(NetworkParam.ver[1] != VER_L))
    {
        NetworkParam.ver[0] = VER_H;
        NetworkParam.ver[1] = VER_L;
        user_flash_write((unsigned char *)&NetworkParam);
    }

    setSIPR(NetworkParam.ip);
    setGAR(NetworkParam.gw);
    setSUBR(NetworkParam.subnet);
    setSHAR(NetworkParam.mac);
}

void Init_Net_DHCP(void)
{
	uint8 xdata i;
	
	if (DHCP_SetIP())
	{   // DHCP success => Init Net
		DHCPisSuccess = 1;
		printf("\r\n> DHCP Success.\r\n",0);
	}
	else
	{	// DHCP Fail	=> Not init Net
		DHCPisSuccess = 0;
		printf("\n\r> DHCP Fail.",0);

		for (i = 0; i < 4; i++)
		{
			NetworkParam.gw[i] = 0;
			NetworkParam.subnet[i] = 0;
			NetworkParam.ip[i] = 0;
		}

		((void (code *)(void)) 0x0000)();
	}
}

//-----------------------------------------------------------------------------
void SetConfig(void)
{   
    // configureNetworkFromEEPROM();
    
    if ((OPT1_Jumper==1) && (OPT2_Jumper==1)) /* DHCP Stuff */ 
    {   
        printf(" - starting DHCP\r\n");
        DHCP_flag = 1;

        if (DHCP_flag == 1)
        {
            Init_Net_Default();		// Init IP,G/W, and S/M by 0.0.0.0
            Init_Net_DHCP();           
        }
        
        // for(;;)
        {
            if ((DHCP_flag == 1) && (DHCPisSuccess == 1)) check_dhcp();
        } 
    } 
    else // manual IP   
    {        
        unsigned char temp;
        temp = NetworkParam.op[0];

        if (( temp != SPECIALOP) || (OPT2_Jumper == 1)) // if the EEPROM hasn't been loaded, or the OPT2 jumper is shorted, set 10.1.1.251
        {
            debug_network();
        }
        else
        if ( OPT1_Jumper == 1) // otherwise, if OPT1 jumper is shorted, set 192.168.1.174
        {
            default_network();
        }
        else // otherwise (if neither OPT jumper, AND the EEPROM HAS been loaded) read IP address out of user EEPROM area.
        {
            //check version out of EEPROM
            if ((NetworkParam.ver[0] != VER_H)||(NetworkParam.ver[1] != VER_L))
            {
                NetworkParam.ver[0] = VER_H;
                NetworkParam.ver[1] = VER_L;
                user_flash_write((unsigned char *)&NetworkParam);
            }
        }

        setSIPR(NetworkParam.ip);
        setGAR(NetworkParam.gw);
        setSUBR(NetworkParam.subnet);
        setSHAR(NetworkParam.mac);
    }
}
//-----------------------------------------------------------------------------
